package domain;

public class DistanzMatrix extends MatrixN {
	public DistanzMatrix(int dim) throws MatrixException {
		super(dim);
	}
	
	@Override
	public void set(int row, int col, int value) throws MatrixException {
		if (value < -1)
			throw new MatrixException("Fehler: nur Werte ab -1 erlaubt!");
		if (row==col && value!=0)
			throw new MatrixException("Fehler: in der Diagonale nur 0 erlaubt!");
			
		super.set(row, col, value);
	}
	
	public void ubernehme(Adjazenz a) throws MatrixException {
		if (getDimension() != a.getDimension())
			throw new MatrixException("Fehler: Dimension nicht gleich!");
		
		for (int z=0; z<a.getDimension(); z++) {
			for (int s=0; s<a.getDimension(); s++) {
				if (z!=s) {
					if (a.get(z, s) != 0) {
						set(z, s, a.get(z, s));
					}
					else {
						set(z, s, -1);						
					}
				}
			}
		}
	}
	
	public boolean ubernehme(Potenz a, int schritte) throws MatrixException {
		if (getDimension() != a.getDimension())
			throw new MatrixException("Fehler: Dimension nicht gleich!");
		
		boolean fertig;
		fertig = true; 
		for (int z=0; z<a.getDimension(); z++) {
			for (int s=0; s<a.getDimension(); s++) {
				if (z!=s) {
					if ((a.get(z, s) != 0) && (get(z, s) == -1)) {
						set(z, s, schritte);
						fertig = false;
					}
				}
			}
		}
		return fertig;
	}
}


















