package domain;

public class MatrixAlgorithmen {
	public static void rotateRight(MatrixN quelle, MatrixN ziel) throws MatrixException {
		if (quelle == null)
			throw new MatrixException("Quellmatrix ist null");
		if (ziel == null)
			throw new MatrixException("Zielmatrix ist null");
		if (quelle.getDimension() != ziel.getDimension())
			throw new MatrixException("Quelle und Ziel haben nicht die selebe Dimension");
		for ( int row = 0; row < quelle.getDimension(); row++ )
	    {
	        for ( int col = 0; col < quelle.getDimension(); col++ )
	        {
	        	ziel.set(col, quelle.getDimension()-1-row, quelle.get(row, col));
	        }
	    }
	}
	
	public static void multiply(MatrixN m1, MatrixN m2, MatrixN ziel) throws MatrixException {
		if ((m1 == null) || (m2 == null) || (ziel == null))
			throw new MatrixException("Fehler: Matrix nicht definiert!");
		if ((m1.getDimension() != m2.getDimension()) || (m1.getDimension() != ziel.getDimension()))
			throw new MatrixException("Fehler: nicht die selbe Dimension!");

		for (int z=0; z<m1.getDimension(); z++) {
			for (int s=0; s<m1.getDimension(); s++) {
				int erg=0;
				for (int i=0; i<m1.getDimension(); i++) {
					erg += m1.get(z, i)*m2.get(i, s);
				}
				ziel.set(z, s, erg);
			}
		}
	}

	public static void add(MatrixN m1, MatrixN m2, MatrixN ziel) throws MatrixException {
		if ((m1 == null) || (m2 == null) || (ziel == null))
			throw new MatrixException("Fehler: Matrix nicht definiert!");
		if ((m1.getDimension() != m2.getDimension()) || (m1.getDimension() != ziel.getDimension()))
			throw new MatrixException("Fehler: nicht die selbe Dimension!");

		for (int z=0; z<m1.getDimension(); z++)
			for (int s=0; s<m1.getDimension(); s++)
				ziel.set(z, s, m1.get(z, s)+m2.get(z, s));
	}

	public static void sub(MatrixN m1, MatrixN m2, MatrixN ziel) throws MatrixException {
		if ((m1 == null) || (m2 == null) || (ziel == null))
			throw new MatrixException("Fehler: Matrix nicht definiert!");
		if ((m1.getDimension() != m2.getDimension()) || (m1.getDimension() != ziel.getDimension()))
			throw new MatrixException("Fehler: nicht die selbe Dimension!");

		for (int z=0; z<m1.getDimension(); z++)
			for (int s=0; s<m1.getDimension(); s++)
				ziel.set(z, s, m1.get(z, s)-m2.get(z, s));		
	}

	public static void ubernehme(MatrixN m1, int value, MatrixN ziel) {
		
	}

	
	public static void berechneDistanzmatrix(Adjazenz quelle, DistanzMatrix ziel) throws MatrixException {		
		Potenz p, p2;
		
		try {
			boolean fertig;
			p = new Potenz(quelle.getDimension());
			p2 = new Potenz(quelle.getDimension());
			System.out.println(quelle);
			ziel.ubernehme(quelle);
			System.out.println("=====================");
			System.out.println(ziel);
			multiply(quelle, quelle, p);
			System.out.println("=====================");
			System.out.println(p);
			fertig = ziel.ubernehme(p,2);
			System.out.println(fertig);
			System.out.println("=====================");
			System.out.println(ziel);
			multiply(p, quelle, p2);
			System.out.println(p2);
			fertig = ziel.ubernehme(p2,3);
			System.out.println(fertig);
			System.out.println("=====================");
			System.out.println(ziel);

			p2.clone(p);
			multiply(p, quelle, p2);
			System.out.println(p2);
			fertig = ziel.ubernehme(p2,4);
			System.out.println(fertig);
			System.out.println("=====================");
			System.out.println(ziel);

			
		}
		catch (MatrixException e) {
			System.err.println(e.getMessage());			
		}
	}
}














